require_relative 'user'

module Sc20XX
  module Models
    # stores information for each track that hits the player
    class Track
      def initialize(hash)
        @hash = hash
      end

      def id
        @hash['id']
      end

      def title
        @hash['title']
      end

      def url
        @hash['permalink_url']
      end

      def user
        @user ||= User.new(@hash['user'])
      end

      def username
        user.username
      end

      def duration
        @hash['duration']
      end

      def length
        TimeHelper.duration(duration)
      end

      def plays
        @hash['playback_count']
      end

      def likes
        @hash['favoritings_count']
      end

      def comments
        @hash['comments']
      end

      def stream_url
        @hash['stream_url']
      end
    end
  end
end
